`line 1 "I:\fa\ssuzuki\microcpu\test.v"
`timescale 1ns/1ps
`ifdef GATE_SIM
`define CYCLE 26.92
`else
`define CYCLE 30
`endif

module test;
        
        reg clock=0;
        reg reset=0;
        reg [15:0] port_in_data=0;
        reg sync=0;
        integer counter=0;

        wire [15:0] port_out_data;
	 wire [39:0] rom_data;
       wire [15:0] pc;

        always #(`CYCLE/2) clock=~clock;
        

        initial begin
		`ifdef GATE
			$dumpvars(1,test);
		`endif
                reset=1;
                #105;
                reset=0;
                #500000;
                $finish;
        end

        always @(negedge clock) begin
                counter=counter+1;
                if(counter>50)
                begin
                        sync = 1;
                        @(negedge clock);
                        sync = 0;
			counter = 0;
                end
        end

/*
        always @(negedge clock) begin
                port_in_data <= port_out_data;
        end
*/

        cpu cpu(.clock,.reset,.sync,.port_in_data(port_in_data),.port_out_data,.pc(pc),.rom_data(rom_data));

endmodule
`line 1 "I:\fa\ssuzuki\microcpu\cpu\micro_rom_xilinx.v"
/*******************************************************************************
*     This file is owned and controlled by Xilinx and must be used             *
*     solely for design, simulation, implementation and creation of            *
*     design files limited to Xilinx devices or technologies. Use              *
*     with non-Xilinx devices or technologies is expressly prohibited          *
*     and immediately terminates your license.                                 *
*                                                                              *
*     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"            *
*     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR                  *
*     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION          *
*     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION              *
*     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS                *
*     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,                  *
*     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE         *
*     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY                 *
*     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE                  *
*     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR           *
*     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF          *
*     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS          *
*     FOR A PARTICULAR PURPOSE.                                                *
*                                                                              *
*     Xilinx products are not intended for use in life support                 *
*     appliances, devices, or systems. Use in such applications are            *
*     expressly prohibited.                                                    *
*                                                                              *
*     (c) Copyright 1995-2006 Xilinx, Inc.                                     *
*     All rights reserved.                                                     *
*******************************************************************************/
// The synopsys directives "translate_off/translate_on" specified below are
// supported by XST, FPGA Compiler II, Mentor Graphics and Synplicity synthesis
// tools. Ensure they are correct for your synthesis tool(s).

// You must compile the wrapper file micro_rom_xilinx.v when simulating
// the core, micro_rom_xilinx. When compiling the wrapper file, be sure to
// reference the XilinxCoreLib Verilog simulation library. For detailed
// instructions, please refer to the "CORE Generator Help".

`timescale 1ns/1ps

module micro_rom_xilinx(
	addr,
	clk,
	dout);


input [10 : 0] addr;
input clk;
output [39 : 0] dout;

// synopsys translate_off

      BLKMEMSP_V6_2 #(
		11,	// c_addr_width
		"0",	// c_default_data
		2048,	// c_depth
		0,	// c_enable_rlocs
		0,	// c_has_default_data
		0,	// c_has_din
		0,	// c_has_en
		0,	// c_has_limit_data_pitch
		0,	// c_has_nd
		0,	// c_has_rdy
		0,	// c_has_rfd
		0,	// c_has_sinit
		0,	// c_has_we
		18,	// c_limit_data_pitch
		"micro_rom_xilinx.mif",	// c_mem_init_file
		0,	// c_pipe_stages
		0,	// c_reg_inputs
		"0",	// c_sinit_value
		40,	// c_width
		0,	// c_write_mode
		"0",	// c_ybottom_addr
		1,	// c_yclk_is_rising
		1,	// c_yen_is_high
		"hierarchy1",	// c_yhierarchy
		0,	// c_ymake_bmm
		"16kx1",	// c_yprimitive_type
		1,	// c_ysinit_is_high
		"1024",	// c_ytop_addr
		0,	// c_yuse_single_primitive
		1,	// c_ywe_is_high
		1)	// c_yydisable_warnings
	inst (
		.ADDR(addr),
		.CLK(clk),
		.DOUT(dout),
		.DIN(),
		.EN(),
		.ND(),
		.RFD(),
		.RDY(),
		.SINIT(),
		.WE());


// synopsys translate_on

// FPGA Express black box declaration
// synopsys attribute fpga_dont_touch "true"
// synthesis attribute fpga_dont_touch of micro_rom_xilinx is "true"

// XST black box declaration
// box_type "black_box"
// synthesis attribute box_type of micro_rom_xilinx is "black_box"

endmodule


`line 1 "I:\fa\ssuzuki\microcpu\micro_cpu_w_sync_rom.v"
//  }CNvO CPU

// lCeBuR}h
`define ADD_com         5'b00000
`define SET_com         5'b00001
`define SUB_com         5'b00010
`define SHIFT_L_com     5'b00011
`define SHIFT_R_com     5'b00100
`define JMP_com         5'b00101
`define SYNC_com        5'b00110

`define AND_com         5'b00111
`define OR_com          5'b01000
`define XOR_com         5'b01001
`define NOT_com         5'b01010

`define MUL_com         5'b01011

`define BSHIFT_L_com    5'b01100
`define BSHIFT_R_com    5'b01101


// Wv
`define Eq              4'b0000
`define Not_Eq          4'b0001
`define Always          4'b0010
`define LT              4'b0011
`define GT              4'b0100
`define LTE             4'b0101
`define GTE             4'b0110

// WX^AhX
`define ZR              4'b0000
`define R0              4'b0001
`define R1              4'b0010
`define R2              4'b0011
`define R3              4'b0100
`define P_IN            4'b0101
`define P_OUT           4'b0110


`define Debug
//`define ALTERA
// CPU
module cpu(input clock, reset,
           input [15:0] port_in_data,
           input sync,
           output [15:0] port_out_data
`ifdef Debug
					,
					 output [39:0] rom_data,
					 output	reg [15:0] pc
`endif
);

localparam integer Loop_counter_width=16;
localparam integer Stop_count = 2**Loop_counter_width -1;
reg [Loop_counter_width-1:0] loop_counter;

`ifndef Debug
reg [15:0] pc;
reg [15:0] pc_com;//gݍ킹WbN
`endif
// reg [15:0] port_in_reg;

reg sync_ff, sync_ff2;

/*----------------------------------------------------------------------------
ROMC[}bv
rbgʒu  rbg  e
39:35       5        
34:31       4        WX^t@CA|[g̃AhX
30:27       4        WX^t@CB|[g̃AhX
26:23       4        WX^t@CCg|[g̃AhX
22:19       4        Wvr
18:16       3        gp
16:16       1        loop_flag [v邩ǂ̃tOAPŃ[v
15:0        16       l܂́Aѐ
-----------------------------------------------------------------------------*/
`ifndef Debug
wire [39:0] rom_data;
`endif
wire [4:0]  command        = rom_data[39:35];
wire [3:0]  A_address      = rom_data[34:31];
wire [3:0]  B_address      = rom_data[30:27];
wire [3:0]  write_address  = rom_data[26:23];
wire [3:0]  jump_cond      = rom_data[22:19];
wire [2:0]  reserved       = rom_data[18:16];
wire [15:0] immediate_data = rom_data[15:0];
wire loop_flag             = reserved[0];

wire [15:0] out_dataA, out_dataB;
wire [15:0] alu_data;


// SETR}h̎́A"A|[gɑl" ڑB
//  ALU [WX^ƉZđ鎖ŁASETׁB
wire [15:0] Aport_data = (command==`SET_com) ? immediate_data : port_in_data;



//[vJE^Zbg
wire Reset_loop_counter = (loop_counter<2)||
                          (loop_counter==Stop_count && immediate_data == 16'b0)
                          ? 1 : 0;
//[vJE^̏
always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                loop_counter <= Stop_count;
        end
        else if(Reset_loop_counter)
        begin
                loop_counter <= Stop_count;
        end
        else if(loop_flag && loop_counter==Stop_count)
        begin
                // [vJEglZbg
                loop_counter <= immediate_data;
        end
        //else if ((loop_flag) && (loop_counter>1))
        else if(loop_flag)
        begin
                // [v
                loop_counter <= loop_counter - 16'b1;
        end
        else
        begin
                loop_counter <= Stop_count;
        end
end


// ͓GbWo
always @(posedge clock, posedge reset) begin
        if (reset) sync_ff<=0;
        else    sync_ff<=sync;
end
always @(posedge clock, posedge reset) begin
        if (reset) sync_ff2<=0;
        else    sync_ff2<=sync_ff;
end
// オGbWo
wire sync_pos_edge_detected = sync_ff & ~sync_ff2;



// }CNvOJE^
reg reset_sync;
always @(clock) reset_sync<=reset;// pcgݍ킹H́ÂKv

//pc gݍ킹H
//Altera sync rom ́AKAddressb`Ă܂̂ŁA
//pcnĂ܂̂́APCLK@DELAYɂȂĂ܂Bh
//߂ɎAhXgݍ킹HœnBb`PCDuplicate삷
reg [15:0] pc_com;
always @* begin
 	if(reset_sync)
        begin
                pc_com= 0;
        end
        // Wvߏ
        else if(command==`JMP_com && alu_data[0]==1'b1)
        begin
                //ł
                pc_com= immediate_data;
        end
        else if(command==`SYNC_com)
        begin   //҂X^[g
                if(sync_pos_edge_detected)
                begin
                        //MoB̃AhXsJnB
                        pc_com= pc + 1;
                end
                else
                begin
                        //GbW܂ő҂
                        pc_com= pc;
                end
        end
        else if(loop_flag)
        begin   //[v
                if(Reset_loop_counter)
                begin
                        //[v甲
                        pc_com= pc + 1;
                end
                else
                begin
                        //_EJEg͑҂
                        pc_com= pc;
                end
        end
        else
        begin
                // Ȃ͎̃AhXsJn
                pc_com= pc + 1;
        end
end

always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                pc <= 0;
        end
        else pc<=pc_com;
      
end





// WX^t@C
register_file register_file(.clock(clock),
                        .reset(reset),
                        .A_address(A_address),
                        .B_address(B_address),
                        .write_address(write_address),
                        .alu_data(alu_data),
                        .out_dataA(out_dataA),
                        .out_dataB(out_dataB),
                        .port_in_data(Aport_data),
                        .port_out_data(port_out_data));

// ALU
alu  alu(.command(command),
         .jump_cond(jump_cond),
         .portA(out_dataA),
         .portB(out_dataB),
         .alu_out(alu_data));

// ROM
`ifdef ALTERA
	micro_rom rom(.address(pc_com),.q(rom_data),.clock(clock));

`else
	`ifdef XILINX
		//reg [39:0] q;
	//	wire [39:0] dout;
	//	always @(posedge clock) q<=dout;
		//assign rom_data=q;
		micro_rom_xilinx rom(.addr(pc),.dout(rom_data),.clk(clock));
	`else
		rom rom(.rom_address(pc_com),.Data(rom_data),.clock(clock));
		
	`endif
`endif

endmodule





// WX^t@C
// LfqWX^̏W܂ƂāA܂Ƃ߂ăW[B
// ɓǂݏł|[gR
// Cg|[gPA[h|[gQB
module register_file(input  clock,
                     input  reset,
                     input  [3:0] A_address,
                     input  [3:0] B_address,
                     input  [3:0] write_address,
                     input  [15:0] alu_data, port_in_data,
                     output [15:0] out_dataA, out_dataB, port_out_data);

// CPUWX^
reg [15:0] p_out_reg, r0, r1, r2, r3;

// |[gAEgWX^
always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                p_out_reg <= 0;
        end
        else if(write_address == `P_OUT)
        begin
                p_out_reg <= alu_data;
        end
        else
        begin
                p_out_reg <= p_out_reg;
        end
end


// ėpWX^R0
always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r0 <= 0;
        end
        else if(write_address == `R0)
        begin
                r0 <= alu_data;
        end
        else
        begin
                r0 <= r0;
        end
end


// ėpWX^R1
always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r1 <= 0;
        end
        else if(write_address == `R1)
        begin
                r1 <= alu_data;
        end
        else
        begin
                r1 <= r1;
        end
end


// ėpWX^R2
always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r2 <= 0;
        end
        else if(write_address == `R2)
        begin
                r2 <= alu_data;
        end
        else
        begin
                r2 <= r2;
        end
end


// ėpWX^R3
always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r3 <= 0;
        end
        else if(write_address == `R3)
        begin
                r3 <= alu_data;
        end
        else
        begin
                r3 <= r3;
        end
end


// A|[go(ALU)
assign out_dataA = (A_address==`P_OUT) ? p_out_reg :
                   (A_address==`P_IN)  ? port_in_data :
                   (A_address==`R0) ? r0 :
                   (A_address==`R1) ? r1 :
                   (A_address==`R2) ? r2 :
                   (A_address==`R3) ? r3 : 16'b0;

// B|[go(ALU)
assign out_dataB = (B_address==`P_OUT) ? p_out_reg :
                   (B_address==`P_IN)  ? port_in_data :
                   (B_address==`R0) ? r0 :
                   (B_address==`R1) ? r1 :
                   (B_address==`R2) ? r2 :
                   (B_address==`R3) ? r3 : 16'b0;

// o̓|[g(̂܂܏o)
assign port_out_data = p_out_reg;

endmodule



// ALU
module alu(input [4:0] command,
           input [3:0] jump_cond,
           input [15:0] portA,portB,
           output reg [15:0] alu_out);

always @(*) begin
        case (command) 
                `ADD_com:     alu_out=portA+portB;
                `SUB_com:     alu_out=portA-portB;
                `SHIFT_L_com: alu_out=portB << 1;
                `SHIFT_R_com: alu_out=portB >> 1;

                `BSHIFT_L_com:alu_out=portA << portB;
                `BSHIFT_R_com:alu_out=portA >> portB;

                `MUL_com:     alu_out=portA * portB;


                `AND_com:     alu_out=portA & portB;
                `OR_com:      alu_out=portA | portB;
                `XOR_com:     alu_out=portA ^ portB;
                `NOT_com:     alu_out=~portA;

                `JMP_com:
                case (jump_cond) 
                        `Eq:            alu_out=(portA == portB);
                        `Not_Eq:        alu_out=(portA != portB);
                        `Always:        alu_out=1;
                        `LT:    if (portA < portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                        `GT:    if (portA > portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                        `LTE:   if (portA <= portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                        `GTE:   if (portA >= portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                        default:        alu_out=0;
                endcase

                default: alu_out=portA+portB;
        endcase
end
endmodule






module rom(input  [15:0] rom_address,
		    input clock,//VNiXROMɕύX
           output reg [39:0] Data);


//assign Data = romdata(rom_address);//VNiXROMɕύX

//TAK start
wire [4:0]  command        = Data[39:35];
wire [3:0]  A_address      = Data[34:31];
wire [3:0]  B_address      = Data[30:27];
wire [3:0]  write_address  = Data[26:23];
wire [3:0]  jump_cond      = Data[22:19];
wire [15:0] im_val=Data[15:0];
wire [2:0] loop_cond=Data[18:16];
//TAK end

// R}h
parameter [4:0] Set=`SET_com,
                Add=`ADD_com,
                Sub=`SUB_com,
                Shift_L=`SHIFT_L_com,
                Shift_R=`SHIFT_R_com,
                Jmp=`JMP_com,
                Sync=`SYNC_com,
                Mul=`MUL_com,
                And=`AND_com,
                Or =`OR_com,
                Xor=`XOR_com,
                Not=`NOT_com,
                BShift_L=`BSHIFT_L_com,
                BShift_R=`BSHIFT_R_com;

parameter [4:0] \Zbg =`SET_com,
                \Z =`ADD_com,
                \Z =`SUB_com,
                \Vtg =`SHIFT_L_com,
                \EVtg =`SHIFT_R_com,
                \Wv =`JMP_com,
                \VN =`SYNC_com,
                \Z =`MUL_com,
                \ =`AND_com,
                \OR  =`OR_com,
                \XOR =`XOR_com,
                \NOT =`NOT_com,
                \oVtg =`BSHIFT_L_com,
                \EoVtg =`BSHIFT_R_com;

// WX^AhX
parameter [3:0] P_OUT=`P_OUT,//IO|[go
                P_IN=`P_IN,  //IO|[g
                R0= `R0,
                R1= `R1,
                R2= `R2,
                R3= `R3,
                ZR= `ZR; // [WX^ (= [GND)

// Wv
parameter [3:0] Eq=`Eq,
                Not_Eq=`Not_Eq,
                Always=`Always,
                LT=`LT,
                GT=`GT,
                LTE=`LTE,
                GTE=`GTE;

// [v
parameter [2:0] Reserved    = 3'b000,
                LoopEnabled = 3'b001;



// }N

// NOP
`define NOP          romdata={Add,ZR,ZR,ZR,Eq,Reserved,16'h 0000}
// Rs[   : r0  r1
`define MOV(r0,r1)   romdata={Add,r0,ZR,r1,Eq,Reserved,16'h 0000}
// NA   : r0 = 0
`define CLR(r0)      romdata={Add,ZR,ZR,r0,Eq,Reserved,16'h 0000}
// 萔 : r0 = num
`define SET(r0,num)  romdata={Set,P_IN,ZR,r0,Eq,Reserved,16'd num}
// Wv
`define JUMP(num)    romdata={Jmp,ZR,ZR,ZR,Always,Reserved,16'd num}

// _]
`define NOT(r0,r1)   romdata={Not,r0,ZR,r1,Always,Reserved,16'h 0000}


// Z   : r2 = r0 + r1
`define ADD(r0,r1,r2) romdata={Add,r0,r1,r2,Eq,Reserved,16'h 0000}
// Z   : r2 = r0 - r1
`define SUB(r0,r1,r2) romdata={Sub,r0,r1,r2,Eq,Reserved,16'h 0000}
// Z     : r2 = r0 * r1
`define MUL(r0,r1,r2) romdata={Mul,r0,r1,r2,Eq,Reserved,16'h 0000}




//  : if(r0<r1) goto num;
`define JUMP_IF_LT(r0,r1,num) romdata={Jmp,r0,r1,ZR,LT,Reserved,16'd num}
//  : if(r0>r1) goto num;
`define JUMP_IF_GT(r0,r1,num) romdata={Jmp,r0,r1,ZR,GT,Reserved,16'd num}

//  : if(r0<=r1) goto num;
`define JUMP_IF_LTE(r0,r1,num) romdata={Jmp,r0,r1,ZR,LTE,Reserved,16'd num}
//  : if(r0>=r1) goto num;
`define JUMP_IF_GTE(r0,r1,num) romdata={Jmp,r0,r1,ZR,GTE,Reserved,16'd num}

//  : if(r0==r1) goto num;
`define JUMP_IF_EQ(r0,r1,num) romdata={Jmp,r0,r1,ZR,Eq,Reserved,16'd num}


// 1rbgVtg
`define SHIFT_L(r0,r1)     romdata={Shift_L,ZR,r0,r1,Eq,Reserved,16'h 0000}
`define SHIFT_R(r0,r1)     romdata={Shift_R,ZR,r0,r1,Eq,Reserved,16'h 0000}
// oVtg
`define BSHIFT_L(r0,r1,r2) romdata={BShift_L,r0,r1,r2,Eq,Reserved,16'h 0000}
`define BSHIFT_R(r0,r1,r2) romdata={BShift_R,r0,r1,r2,Eq,Reserved,16'h 0000}


// ÓEオGbW܂ő҂
`define SYNC           romdata={Sync,ZR,ZR,ZR,Eq,Reserved,16'h 0000}


// [vJԂ(JUMPߕ1NbNߖ)
// ex : r2 = r0 + r1  num+1 JԂB̊ԁApc  AhXőҋ@B
`define ADD_LOOP(r0,r1,r2,num) romdata={Add,r0,r1,r2,Eq,LoopEnabled,16'd num}
`define SUB_LOOP(r0,r1,r2,num) romdata={Sub,r0,r1,r2,Eq,LoopEnabled,16'd num}
`define MUL_LOOP(r0,r1,r2,num) romdata={Mul,r0,r1,r2,Eq,LoopEnabled,16'd num}
`define SHIFT_L_LOOP(r0,num) romdata={Shift_L,ZR,r0,r0,Eq,LoopEnabled,16'd num}
`define SHIFT_R_LOOP(r0,num) romdata={Shift_R,ZR,r0,r0,Eq,LoopEnabled,16'd num}


//Tak start @tAZu
reg [8*40:1] str;
function [8*3:1] get_rn(input [3:0] addr);
	case (addr) 
			P_OUT: get_rn="OUT";
			P_IN:    get_rn="IN";  //IO|[g
                   R0:      get_rn="R0";
                   R1:      get_rn="R1";
                   R2:      get_rn="R2";
                   R3:      get_rn="R3";
                   ZR:      get_rn="ZR"; // [WX^ (= [GND)
			default: get_rn="???";
	endcase
endfunction

always @* begin
	case (command) 
		Add:
			if(loop_cond==0) begin
				if (A_address==ZR && B_address==ZR & write_address==ZR)  $sformat(str,"NOP");
				else if (B_address==ZR &&  A_address==ZR ) $sformat(str,"%sNA",get_rn(write_address));	
				else if (B_address==ZR ) $sformat(str,"%s%sփRs[",get_rn(A_address),get_rn(write_address));
				else $sformat(str,"%s=%s + %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			 end else begin
				if (A_address==ZR && B_address==ZR & write_address==ZR)  $sformat(str,"NOP %d[vt",im_val);
				else if (B_address==ZR &&  A_address==ZR ) $sformat(str,"%sNA@ %d[vt",get_rn(write_address),im_val);	
				else if (B_address==ZR ) $sformat(str,"%s%sփRs[@ %d[vt",get_rn(A_address),get_rn(write_address),im_val);
				else  $sformat(str,"%s=%s + %s  %d[vt",get_rn(write_address),get_rn(A_address),get_rn(B_address),im_val);
			end
		Set:  $sformat(str,"%s=%h[Hex]",get_rn(write_address),im_val);
		Mul:
			if (loop_cond==0) begin
				 $sformat(str,"%s=%s * %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			end else $sformat(str,"%s=%s * %s @ %d[vt",get_rn(write_address),get_rn(A_address),get_rn(B_address),im_val);
		Sub:
			if (loop_cond==0) begin
				 $sformat(str,"%s=%s - %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			end else  $sformat(str,"%s=%s - %s  %d[vt",get_rn(write_address),get_rn(A_address),get_rn(B_address),im_val);
		Sync:
			$sformat(str,"VN");
			
		Not: $sformat(str,"%s=~%s",get_rn(write_address),get_rn(A_address));
		Jmp:
			if (jump_cond==Always) $sformat(str,"%dԒnփWv",im_val);
			else if (jump_cond==LT) $sformat(str,"%s < %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val);
			else if (jump_cond==GT) $sformat(str,"%s > %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val);
			else if (jump_cond==LTE) $sformat(str,"%s <= %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val);
			else if (jump_cond==GTE) $sformat(str,"%s >= %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val); 
			else if (jump_cond==Eq)  $sformat(str,"%s == %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val); 
		Shift_L:
				if (loop_cond==0)		$sformat(str,"%s=%s << 1",get_rn(write_address),get_rn(B_address));
				else			      $sformat(str,"%s=%s << %d",get_rn(write_address),get_rn(B_address),im_val);
			 
		Shift_R: 
				if (loop_cond==0)		$sformat(str,"%s=%s >> 1",get_rn(write_address),get_rn(B_address));
				else			      $sformat(str,"%s=%s >> %d",get_rn(write_address),get_rn(B_address),im_val);

		BShift_L:
			      $sformat(str,"%s=%s <<%s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			 
		BShift_R: 
			      $sformat(str,"%s=%s >> %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));

	endcase
end

//Tak end

// }CNR[h
`define PHY_ADD_MAX (1024*2-1)
//ALTERA@ROM̖͋[R[h
	reg [39:0] micro_rom [0:`PHY_ADD_MAX];
 	reg [15:0] address_latch;

	always @(posedge clock) address_latch<=rom_address;
	always @(posedge clock ) begin//q latch o͕tɂ
			Data<=micro_rom[address_latch];
	end
`ifdef RTL_SIM
	integer i;
	initial begin
		for (i=0;i<= `PHY_ADD_MAX;i=i+1) begin
				micro_rom[i]=romdata(i);
		end
		make_intel_hex(5,`PHY_ADD_MAX);//RTL SIMINTEL@HEXt@C𐶐 Altera p
		make_coe_file(5,`PHY_ADD_MAX);//RTL SIMXilinxp@Coet@C𐶐
	end
`endif

//memory ̓eAltera@ROMp
//intel-hextH[}bgɕϊ
//t@C->rom.hex Ƃďo͂
//address 64K word max
//zx܂܂Ȃ
task make_intel_hex(input [7:0]  bytes_per_word,
				   input integer address_max);
		reg [9*8:1] str;
		integer fi;
		reg [15:0]   ad;
		integer bytes;
	      reg [7:0] parity;
		begin
			fi=$fopen("rom.hex","w");
			
			for (ad=0;ad <=address_max;ad=ad+1) begin
				$sformat(str,":%2h%4h00",bytes_per_word,ad);
				parity=bytes_per_word;
				parity =parity + ad[8*1 +:8];//`FbNT
				parity =parity + ad[0     +:8];//`FbNT
				

				$fwrite(fi,"%s",str);	
				for (bytes=0;bytes<bytes_per_word;bytes=bytes+1) begin: byte_loop
					reg [7:0] byte;
					byte=micro_rom[ad][(bytes_per_word-1-bytes)*8 +:8]; 
					parity=parity+byte;//`FbNT
				
					$fwrite(fi,"%2h",byte);
				end
				parity=~parity +8'h01;//`FbNT
				$fwrite(fi,"%2h",parity);
				$fwrite(fi,"\n");
			end
			$fdisplay(fi,":00000001FF");
			$fclose(fi);
			str="rom.ver";
			$convert_hex2ver("rom.hex",40,str);//`FbNVeritak@Uniquet@NV
		end
endtask

//xilinx coe file
task make_coe_file(input [7:0]  bytes_per_word,
				   input integer address_max);
	integer fi;
	integer ad;
	begin
		fi=$fopen("rom.coe","w");
		$fdisplay(fi,"memory_initialization_radix=16;");
		$fdisplay(fi,"memory_initialization_vector=");
		for (ad=0;ad <address_max;ad=ad+1) begin
			$fdisplay(fi,"%h,",micro_rom[ad]);
		end
		$fdisplay(fi,"%h;",micro_rom[address_max]);
		$fclose(fi);
	end
endtask
				  

function [39:0]romdata;
        input [15:0] address;
        case(address)
        //Commad  A_addr, B_addr, Write_addr, Jmp_cond, Reserved, IM
        0: `SET(P_OUT, 100);
        1: `SET(R0, 5);
        2: `MOV(R0, R1);
        3: `MOV(R1, R2);
        4: `MOV(R2, R3);
        5: `SUB(R1, R2, R0);
        6: `SUB(R3, R1, R3);
        7: `ADD(P_IN, P_OUT, P_OUT);
        8: `ADD(P_OUT, P_OUT, P_OUT);
        9: `SUB(P_IN, P_IN, R1);
        10: `SUB(P_OUT, P_IN, R2);
        11: `SET(R0, 2);
        12: `SET(R1, 8);
        13: `MUL(R0, R1, R3);
        14: `NOP;
        15: `MUL(R3, R3, R3);
        16: `ADD(P_OUT, R3, P_OUT);
        17: `SYNC;
        18: `JUMP(1000);

        // VtgEZ
        1000: `SET(R0, 5);
        1001: `SET(R1, 2);
        1002: `ADD_LOOP(R0, R1, R0, 10);
        1003: `SHIFT_L_LOOP(R1, 5);
        1004: `SHIFT_R_LOOP(R1, 5);
        1005: `SUB_LOOP(R0, R1, R0, 10);
        1006: `SET(P_OUT, 5);
        1007: `MUL_LOOP(P_OUT, R1, P_OUT, 7);
        1008: `JUMP(1500);

        // 
        1500: `SET(R0, 16);
        1501: `SET(R1, 2);
        1502: `SET(P_OUT, 0);
        1503: `SUB(R0, R1, R0);
        1504: `JUMP_IF_GT(R0, R1 ,1503);
	  1505: `NOP ;//NOP} @fBChXbg
        // 
        1506: `SET(R2, 16);
        1507: `SET(R3, 2);
        1508: `SET(P_OUT, 0);
        1509: `SUB(R2, R3, R2);
        1511: `JUMP_IF_GTE(R2, R3 ,1509);
	  1512:`NOP;//NOP}@fBChXbg
        // 1010_1010_1010_1010
        // rbg]
        1513: `SET(R0, 43690);
        1514: `NOT(R0, R1);

        // oVt^
        1515: `SET(R0, 2);
        1516: `SET(R1, 7);
        1517: `SET(R2, 0);
        1518: `BSHIFT_L(R0, R1, R0);
        1519: `BSHIFT_R(R0, R1, R0);

	1520: `JUMP(0);

        default:  romdata = 0;
        endcase
endfunction
endmodule

`line 1 "E:\Xilinx8.2\verilog\src\XilinxCoreLib\BLKMEMSP_V6_2.v"
// Copyright(C) 2004 by Xilinx, Inc. All rights reserved. 
// This text/file contains proprietary, confidential 
// information of Xilinx, Inc., is distributed under license 
// from Xilinx, Inc., and may be used, copied and/or 
// disclosed only pursuant to the terms of a valid license 
// agreement with Xilinx, Inc. Xilinx hereby grants you 
// a license to use this text/file solely for design, simulation, 
// implementation and creation of design files limited 
// to Xilinx devices or technologies. Use with non-Xilinx 
// devices or technologies is expressly prohibited and 
// immediately terminates your license unless covered by 
// a separate agreement. 
// 
// Xilinx is providing this design, code, or information 
// "as is" solely for use in developing programs and 
// solutions for Xilinx devices. By providing this design, 
// code, or information as one possible implementation of 
// this feature, application or standard, Xilinx is making no 
// representation that this implementation is free from any 
// claims of infringement. You are responsible for 
// obtaining any rights you may require for your implementation. 
// Xilinx expressly disclaims any warranty whatsoever with 
// respect to the adequacy of the implementation, including 
// but not limited to any warranties or representations that this 
// implementation is free from claims of infringement, implied 
// warranties of merchantability or fitness for a particular 
// purpose. 
// 
// Xilinx products are not intended for use in life support 
// appliances, devices, or systems. Use in such applications are 
// expressly prohibited. 
// 
// This copyright and support notice must be retained as part 
// of this text at all times. (c) Copyright 1995-2004 Xilinx, Inc. 
// All rights reserved.

/*****************************************************************************
 * $RCSfile: BLKMEMSP_V6_2.v,v $
 *****************************************************************************
 * Block Memory Compiler - Verilog Behavioral Model
 *****************************************************************************
 *
 *
 *************************************************************************
 * Filename:   BLKMEMSP_V6_2.v
 *
 * Decsription: Single Port V2 BRAM behavioral model. Extendable depth/width.
 *              The behavior for EN = `X`, WE = `X`, and for CLK transitions to
 *              or from `X` is not considered.
 *
 **************************************************************************/
`timescale 1ns/10ps

`celldefine


`define c_sp_rom 0
`define c_sp_ram 1
`define c_write_first 0
`define c_read_first  1
`define c_no_change   2

module BLKMEMSP_V6_2(DOUT,  ADDR, DIN,  EN, CLK, WE, SINIT, ND, RFD, RDY);

  parameter  c_addr_width          =  9 ; // controls address width of memory
  parameter  c_default_data        = "0"; // indicates string of hex characters used to initialize memory
  parameter  c_depth               = 512 ; // controls depth of memory
  parameter  c_enable_rlocs        = 0 ; //  core includes placement constraints
  parameter  c_has_default_data    =  1; // initializes contents of memory to c_default_data
  parameter  c_has_din             = 1  ; // indicates memory has data input pins
  parameter  c_has_en              =  1 ; // indicates memory has a EN pin
  parameter  c_has_limit_data_pitch       = 0  ; //  
  parameter  c_has_nd              = 0  ; //  Memory has a new data pin
  parameter  c_has_rdy             = 0  ; //  Memory has result ready pin
  parameter  c_has_rfd             = 0  ; //  Memory has ready for data pin
  parameter  c_has_sinit           =  1 ; // indicates memory has a SINIT pin
  parameter  c_has_we              =  1 ; // indicates memory has a WE pin
  parameter  c_limit_data_pitch           = 18;
  parameter  c_mem_init_file       =  "null.mif";  // controls which .mif file used to initialize memory
  parameter  c_pipe_stages         =  1 ; // indicates the number of pipe stages needed in port A
  parameter  c_reg_inputs          = 0 ;  // indicates WE, ADDR, and DIN are registered
  parameter  c_sinit_value         = "0000"; // indicates string of hex used to initialize  output registers
  parameter  c_width               =  32 ; // controls data width of memory
  parameter  c_write_mode          =  2; // controls which write modes shall be used
   
  parameter  c_ybottom_addr        = "1024";
  parameter  c_yclk_is_rising      = 1;
  parameter  c_yen_is_high         = 1;
  parameter  c_yhierarchy          = "hierarchy1";
  parameter  c_ymake_bmm           = 1;
  parameter  c_yprimitive_type     = "4kx4";
  parameter  c_ysinit_is_high      = 1;
  parameter  c_ytop_addr           = "0";
  parameter  c_yuse_single_primitive = 0;
  parameter  c_ywe_is_high         = 1;
 parameter   c_yydisable_warnings  = 0;
 

// IO ports


  output [c_width-1:0] DOUT;
  input [c_addr_width-1:0] ADDR;
  input [c_width-1:0] DIN;
  input EN, CLK, WE, SINIT, ND;
  output RFD, RDY;

  reg RFD ;
  reg RDY ;

  reg [c_width-1:0] dout_int; // output of RAM
  reg [c_width-1:0] pipe_out ; // output of pipeline stage
  wire [c_width-1:0] DOUT = pipe_out ;
  reg [c_width-1:0] mem [0:c_depth-1];
  reg [24:0] count;
  reg [1:0] wr_mode;

  wire [c_addr_width-1:0] addr_i = ADDR;
  reg [c_addr_width-1:0] addr_int ;
  reg [c_width-1:0] di_int ;
  wire [c_width-1:0] di_i ;
  wire clk_int ;
  wire en_int ;
  reg we_int  ;
  wire we_i ;
  reg  we_q ;
  wire ssr_int  ;
  wire nd_int ;
  wire nd_i ;
  reg rfd_int ;
  reg rdy_int ;
  reg nd_q ;
  reg [c_width-1:0] di_q ;
  reg [c_addr_width-1:0] addr_q;
  reg new_data ;
  reg new_data_q ; // to track the synchronous PORT RAM output 

  reg [c_width-1:0] default_data ;
  reg [c_width-1:0] ram_temp [0:c_depth-1];
  reg [c_width-1:0] bitval;
  reg [c_width-1:0] sinit_value;

  reg [(c_width-1) : 0] pipeline [0 : c_pipe_stages];
  reg sub_rdy[0 : c_pipe_stages];
  reg [10:0] ci, cj ;
  reg [10:0] dmi, dmj, dni, dnj, doi, doj ;
  integer i, j, k, l, m;
  integer ai, aj, ak, al, am, an, ap ;


// Generate input control signals
// Combinational 

// Take care of ROM/RAM functionality

  assign clk_int = defval(CLK, 1, 1, c_yclk_is_rising);
  assign we_i = defval(WE, c_has_we, 0, c_ywe_is_high);  
  assign di_i  = (c_has_din == 1)?DIN:'b0;
  assign en_int  = defval(EN, c_has_en, 1, c_yen_is_high);
  assign ssr_int = defval(SINIT , c_has_sinit , 0, c_ysinit_is_high);
  assign nd_i = defval (ND, c_has_nd, 1, 1);


//    tri0 GSR = glbl.GSR;

  function defval;
    input i;
    input hassig;
    input val;  
    input active_high;
  begin
    if(hassig == 1)
    begin
      if (active_high == 1)
        defval = i;
      else
        defval = ~i;
    end
    else
      defval = val;
  end
  endfunction

  function max;
    input a;  
    input b;
  begin
    max = (a > b) ? a : b;
  end
  endfunction
 
  function a_is_X;
    input [c_width-1 : 0] i;
    integer j ;
  begin
    a_is_X = 1'b0;
    for(j = 0; j < c_width; j = j + 1)
    begin
      if(i[j] === 1'bx)
        a_is_X = 1'b1;
    end // loop
  end
  endfunction


  function [c_width-1:0] hexstr_conv;
    input [(c_width*8)-1:0] def_data;

    integer index,i,j;
    reg [3:0] bin;   

  begin
    index = 0; 
    hexstr_conv = 'b0; 
    for( i=c_width-1; i>=0; i=i-1 )
    begin
      case (def_data[7:0])
        8'b00000000 :  
      begin
        bin = 4'b0000;
        i = -1;
      end
      8'b00110000 : bin = 4'b0000;
      8'b00110001 : bin = 4'b0001;
      8'b00110010 : bin = 4'b0010;
      8'b00110011 : bin = 4'b0011;
      8'b00110100 : bin = 4'b0100;
      8'b00110101 : bin = 4'b0101;
      8'b00110110 : bin = 4'b0110;
      8'b00110111 : bin = 4'b0111;
      8'b00111000 : bin = 4'b1000;
      8'b00111001 : bin = 4'b1001;
      8'b01000001 : bin = 4'b1010;
      8'b01000010 : bin = 4'b1011;
      8'b01000011 : bin = 4'b1100;
      8'b01000100 : bin = 4'b1101;
      8'b01000101 : bin = 4'b1110;
      8'b01000110 : bin = 4'b1111;
      8'b01100001 : bin = 4'b1010;
      8'b01100010 : bin = 4'b1011;
      8'b01100011 : bin = 4'b1100;
      8'b01100100 : bin = 4'b1101;
      8'b01100101 : bin = 4'b1110;
      8'b01100110 : bin = 4'b1111;
      default :
        begin
          if (c_yydisable_warnings == 0) begin
            $display("ERROR in %m at time %t : NOT A HEX CHARACTER",$time);
          end
          bin = 4'bx;
        end
      endcase
      for( j=0; j<4; j=j+1)
      begin
        if ((index*4)+j < c_width)
        begin
          hexstr_conv[(index*4)+j] = bin[j];
        end 
      end
      index = index + 1;
      def_data = def_data >> 8;
    end
  end
  endfunction

  initial begin
    sinit_value  = 'b0 ;
    default_data = hexstr_conv(c_default_data);
    if (c_has_sinit == 1 )
      sinit_value = hexstr_conv(c_sinit_value);
    for(i = 0; i < c_depth; i = i + 1)
      mem[i] = default_data;
    if (c_has_default_data == 0)
      $readmemb(c_mem_init_file, mem);
    for (k = 0; k <= c_pipe_stages; k = k + 1)
      pipeline[k] = sinit_value ;
    for (m = 0; m <= c_pipe_stages; m = m + 1)
      sub_rdy[m] = 0 ;
    dout_int = sinit_value ;
    nd_q = 0 ;
    new_data_q = 0 ;
    di_q = 0 ;
    addr_q = 0 ;
    we_q = 0 ;
    #1 pipe_out = sinit_value;
  end

//  Generate output control signals RFD and  RDY 
//  Combinational

    always @ ( rfd_int)
    begin
      if (c_has_rfd == 1) 
        RFD = rfd_int ;
      else
        RFD = 1'b0 ;
    end

    always @ (en_int )
    begin
      if (en_int == 1'b1)
        rfd_int = 1'b1 ;
      else
        rfd_int = 1'b0 ;
    end

    always @ (  rdy_int )
    begin
      if ((c_has_rdy == 1) && (c_has_nd == 1) && (c_has_rfd == 1) )
        RDY = rdy_int ;
      else
        RDY = 1'b0 ;
    end

    assign nd_int = en_int && nd_i ; // only pass nd through if en is 1 

// Register hanshaking inputs

    always @(posedge clk_int )
    begin
      if (en_int == 1'b1)
      begin
        if (ssr_int == 1'b1)
          nd_q <= 1'b0 ;
        else
          nd_q   <= nd_int;
        end
      else
        nd_q   <= nd_q ;
    end
// Register data / address / data inputs

  always @(posedge clk_int )
  begin
    if (en_int == 1'b1)
      begin
        di_q  <= di_i ;
        addr_q <= addr_i ;
        we_q <= we_i ;
      end
  end

// select registered or non-registered write enable

  always @( we_i or we_q)
  begin
    if (c_reg_inputs == 1 )
      we_int = we_q ;
     else
      we_int = we_i ;
  end

// select registered data/address/nd inputs

  always @( di_i or di_q)
  begin
    if ( c_reg_inputs == 1)
      di_int = di_q ;
    else
      di_int = di_i ;
  end

  always @( addr_i or addr_q or nd_q or nd_int or we_q or we_i)
  begin
    if (c_reg_inputs == 1)
      begin
        addr_int = addr_q;
        if ((we_q == 1'b1) && (c_write_mode == 2))
          new_data = 1'b0 ;
       	else     
          new_data = nd_q ;
      end
    else
      begin
        addr_int = addr_i ;
        if ((we_i == 1'b1) && (c_write_mode == 2))
          new_data = 1'b0 ;
       	else        
          new_data = nd_int ;
      end
  end

// Register the new_data signal to track the synchronous RAM output

  always @(posedge clk_int)
  begin
    if ( en_int == 1'b1 )
      begin
       if (ssr_int == 1'b1)
          new_data_q <= 0 ;
       else
          new_data_q <= new_data ;
      end
  end

   initial begin
     case (c_write_mode)
       `c_write_first : wr_mode <= 2'b00;
       `c_read_first  : wr_mode <= 2'b01;
       `c_no_change   : wr_mode <= 2'b10;
       default        : begin
         if (c_yydisable_warnings == 0) begin
	   $display("Error in %m at time %t: c_write_mode = %s is not WRITE_FIRST, READ_FIRST or NO_CHANGE.",$time , c_write_mode);
         end
	 $finish;
       end
     endcase
   end


    /***************************************************************
    *The following always block assigns the value for the DOUT bus
    ***************************************************************/   
   always @(posedge clk_int) begin
     if (en_int == 1'b1) begin
       if (ssr_int == 1'b1) begin
           dout_int <= sinit_value;
       end
       else begin
	 //The following IF block assigns the output for a write operation
         if (we_int == 1'b1) begin
           if (wr_mode == 2'b00) begin
             if (addr_int < c_depth) 
                 dout_int <= di_int;
             else
	       //Warning Condition (Error occurs on rising edge of CLK): 
	       //Write Mode Port is "Write First" and EN = 1 and SINIT = 0 and WE = 1 and ADDR out of the valid range
               if (c_yydisable_warnings == 0) begin
	         $display("Invalid Address Warning #1: Warning in %m at time %t: Block memory address %d (%b) invalid. Valid depth configured as 0 to %d",$time,addr_int,addr_int,c_depth-1);    
               end
           end
           else if (wr_mode == 2'b01) begin
             if (addr_int < c_depth) 
               dout_int <= mem[addr_int];
             else
	       //Warning Condition (Error occurs on rising edge of CLK): 
	       //Write Mode Port is "Read First" and EN = 1 and SINIT = 0 and WE = 1 and ADDR out of the valid range
              if (c_yydisable_warnings == 0) begin
	        $display("Invalid Address Warning #2: Warning in %m at time %t: Block memory address %d (%b) invalid. Valid depth configured as 0 to %d",$time,addr_int,addr_int,c_depth-1);
              end
           end
           else begin
             if (addr_int < c_depth) 
               dout_int <= dout_int ;
             else
	      //Warning Condition (Error occurs on rising edge of CLK): 
	       //Write Mode Port is "No Change" and EN = 1 and SINIT = 0 and WE = 1 and ADDR out of the valid range
              if (c_yydisable_warnings == 0) begin
	        $display("Invalid Address Warning #3: Warning in %m at time %t: Block memory address %d (%b) invalid. Valid depth configured as 0 to %d",$time,addr_int,addr_int,c_depth-1);
              end
           end
	 end
	 //The following ELSE block assigns the output for a read operation
	 else begin
           if (addr_int < c_depth) 
             dout_int <= mem[addr_int];
           else
             //Warning Condition (Error occurs on rising edge of CLK): 
	     //EN = 1 and SINIT = 0 and WE = 0 and ADDRA out of the valid range 
            if (c_yydisable_warnings == 0) begin
	      $display("Invalid Address Warning #4: Warning in %m at time %t: Block memory address %d (%b) invalid. Valid depth configured as 0 to %d",$time,addr_int,addr_int,c_depth-1);
            end
	 end
       end
     end
   end


// Write to memory contents
    /***************************************************************************************
    *The following always block assigns the DIN bus to the memory during a write operation
    ***************************************************************************************/ 
   always @(posedge clk_int) begin
     if (en_int == 1'b1 && we_int == 1'b1) begin
       if (addr_int < c_depth) 
         mem [addr_int] <= di_int ;
       else
	 //Warning Condition (Error occurs on rising edge of CLK): 
	 //EN = 1 and WE = 1 and ADDR out of the valid range
        if (c_yydisable_warnings == 0) begin
	  $display("Invalid Address Warning #5: Warning in %m at time %t: Block memory address %d (%b) invalid. Valid depth configured as 0 to %d",$time,addr_int,addr_int,c_depth-1);
        end
     end
   end

//  output pipelines 
 
   always @(posedge clk_int) begin
      if (en_int == 1'b1 && c_pipe_stages > 0)
	begin
           for (i = c_pipe_stages; i >= 1; i = i -1 )
             begin
		if (ssr_int == 1'b1 && en_int == 1'b1)
		  begin
		     pipeline[i] <= sinit_value ;
		     sub_rdy[i] <=  0 ;
		  end
		else
		  begin
                    // Do not update output register if no_change on write and
                    // WE = 1
//                    if (!(c_write_mode == 2 && we_int == 1)) begin
                      if (i==1)
                        begin
                          pipeline[i] <= dout_int;
                        end
                      else
                        begin
                          pipeline[i] <= pipeline[i-1] ;
                        end
//                    end // if (!(c_write_mode == 2 && we_int == 1))
                    if (i==1)
                      begin
                        sub_rdy[i]  <= new_data_q;
                      end
                    else
                      begin
                        sub_rdy[i]  <= sub_rdy[i-1] ;
                      end                    
                  end
             end
        end
    end

// Select pipelined data output or no-pipelined data output
 
   always @( pipeline[c_pipe_stages] or sub_rdy[c_pipe_stages] or new_data_q or dout_int) begin
     if (c_pipe_stages == 0 )
     begin
       pipe_out = dout_int ;
       rdy_int = new_data_q ;
     end
     else
     begin
       rdy_int = sub_rdy[c_pipe_stages];
       pipe_out = pipeline[c_pipe_stages];
     end
   end

endmodule

`endcelldefine

`line 1 "E:\Xilinx8.2\verilog\src\XilinxCoreLib\FAMILY.v"
/* $Header: /devl/xcs/repo/env/Databases/ip/src/com/xilinx/ip/unisim/simulation/FAMILY.v,v 1.10.28.1 2006/03/16 21:18:23 julian Exp $
--
-- Description - 
*/

`define any       "any"
`define x4k       "x4k"
`define x4ke      "x4ke"
`define x4kl      "x4kl"
`define x4kex     "x4kex"
`define x4kxl     "x4kxl"
`define x4kxv     "x4kxv"
`define x4kxla    "x4kxla"
`define spartan   "spartan"
`define spartanxl "spartanxl"
`define spartan2  "spartan2"
`define spartan2e "spartan2e"
`define virtex    "virtex"
`define virtexe   "virtexe"
`define virtex2   "virtex2"
`define virtex2p  "virtex2p"
`define spartan3  "spartan3"
`define spartan3e "spartan3e"
`define virtex4   "virtex4"
`define qrvirtex  "qrvirtex"
`define qrvirtex2 "qrvirtex2"
`define qvirtex   "qvirtex"
`define qvirtex2  "qvirtex2"
`define qvirtexe  "qvirtexe"

module family ( );

/*
 * True if architecture "child" is derived from, or equal to,
 * the architecture "ancestor".
 * ANY, X4K, SPARTAN, SPARTANXL
 * ANY, X4K, X4KE, X4KL
 * ANY, X4K, X4KEX, X4KXL, X4KXV, X4KXLA
 * ANY, VIRTEX, SPARTAN2, SPARTAN2E
 * ANY, VIRTEX, VIRTEXE
 * ANY, VIRTEX, VIRTEX2, SPARTAN3, SPARTAN3E
 * ANY, VIRTEX, VIRTEX2, VIRTEX2P
 * ANY, VIRTEX, VIRTEX4
 * ANY, VIRTEX, QRVIRTEX
 * ANY, VIRTEX, VIRTEX2, QRVIRTEX2
 * ANY, VIRTEX, QVIRTEX
 * ANY, VIRTEX, VIRTEX2, QVIRTEX2
 * ANY, VIRTEX, QVIRTEX
 */

function derived;
    input [9*8:1] child;
    input [9*8:1] ancestor;
    begin
        derived = 0;
        if ( child == `virtex ) 
	begin
	    if ( ancestor == `virtex || ancestor == `any )
	    begin
                derived = 1;
            end
	end
    else if ( child == `qvirtexe )
    begin
        if ( ancestor == `qvirtexe || ancestor == `virtex || ancestor == `any )
        begin
            derived = 1;
        end
    end
    else if ( child == `qvirtex2 )
    begin
        if ( ancestor == `qvirtex2 || ancestor == `virtex2 || ancestor == `virtex || ancestor == `any )
        begin
            derived = 1;
        end
    end
    else if ( child == `qvirtex )
    begin
        if ( ancestor == `qvirtex || ancestor == `virtex || ancestor == `any )
        begin
            derived = 1;
        end
    end
    else if ( child == `qrvirtex2 )
    begin
        if ( ancestor == `qrvirtex2 || ancestor == `virtex2 || ancestor == `virtex || ancestor == `any )
        begin
            derived = 1;
        end
    end
    else if ( child == `qrvirtex )
    begin
        if ( ancestor == `qrvirtex || ancestor == `virtex || ancestor == `any )
        begin
            derived = 1;
        end
    end
	else if ( child == `virtex4 )
	begin
	    if ( ancestor == `virtex4 || ancestor == `virtex || ancestor == `any )
	    begin
	        derived = 1;
            end	    
	end
	else if ( child == `virtex2 )
	begin
	    if ( ancestor == `virtex2 || ancestor == `virtex || ancestor == `any )
	    begin
                derived = 1;
            end
	end
	else if ( child == `virtex2p )
	begin
	    if ( ancestor == `virtex2p || ancestor == `virtex2 || ancestor == `virtex || ancestor == `any )
	    begin
	        derived = 1;
            end
	end
	else if ( child == `spartan3e )
	begin
	    if ( ancestor == `spartan3e || ancestor == `spartan3 || ancestor == `virtex2 || ancestor == `virtex || ancestor == `any )
	    begin
	        derived = 1;
            end
	end
	else if ( child == `spartan3 )
	begin
	    if ( ancestor == `spartan3 || ancestor == `virtex2 || ancestor == `virtex || ancestor == `any )
	    begin
	        derived = 1;
            end
	end
	else if ( child == `virtexe )
	begin
	    if ( ancestor == `virtexe || ancestor == `virtex || ancestor == `any )
	    begin
	        derived = 1;
            end	    
	end
	else if ( child == `spartan2 )
	begin
	    if ( ancestor == `spartan2 || ancestor == `virtex || ancestor == `any )
	    begin
	        derived = 1;
            end
	end
	else if ( child == `spartan2e )
	begin
	    if ( ancestor == `spartan2e || ancestor == `spartan2 || ancestor == `virtex || ancestor == `any )
	    begin
	        derived = 1;
            end
	end
        else if ( child == `x4k )
	begin
            if ( ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `x4kex )
	begin
            if ( ancestor == `x4kex || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `x4kxl )
	begin
            if ( ancestor == `x4kxl || ancestor == `x4kex || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `x4kxv )
	begin
            if ( ancestor == `x4kxv || ancestor == `x4kxl || ancestor == `x4kex || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `x4kxla )
	begin
            if ( ancestor == `x4kxla || ancestor == `x4kxv || ancestor == `x4kxl || ancestor == `x4kex || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `x4ke )
	begin
            if ( ancestor == `x4ke || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end 	    
	end
        else if ( child == `x4kl )
	begin
            if ( ancestor == `x4kl || ancestor == `x4ke || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `spartan )
	begin
            if ( ancestor == `spartan || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `spartanxl )
	begin
            if ( ancestor == `spartanxl || ancestor == `spartan || ancestor == `x4k || ancestor == `any )
	    begin
                derived = 1;
            end
	end
        else if ( child == `any )
	begin
            if ( ancestor == `any )
	    begin
                derived = 1;
            end
	end
    end
endfunction //my_func

endmodule
