`line 1 "I:\fa\ssuzuki\Rs[ ` microcpu\test.v"
`timescale 1ns/1ps






module test;
        
        reg clock=0;
        reg reset=0;
        reg [15:0] port_in_data=0;
        reg sync=0;
        integer counter=0;

        wire [15:0] port_out_data;
	 wire [39:0] rom_data;
       wire [15:0] pc;

        always #( 30/2) clock=~clock;
        

        initial begin
		


                reset=1;
                #105;
                reset=0;
                #500000;
                $finish;
        end

        always @(negedge clock) begin
                counter=counter+1;
                if(counter>50)
                begin
                        sync = 1;
                        @(negedge clock);
                        sync = 0;
			counter = 0;
                end
        end







        cpu cpu(.clock,.reset,.sync,.port_in_data(port_in_data),.port_out_data,.pc(pc),.rom_data(rom_data));

endmodule

`line 1 "I:\fa\ssuzuki\Rs[ ` microcpu\micro_cpu.v"












































module cpu(input clock, reset,
           input [15:0] port_in_data,
           input sync,
           output [15:0] port_out_data

					,
					 output [39:0] rom_data,
					 output	reg [15:0] pc

);

localparam integer Loop_counter_width=16;
localparam integer Stop_count = 2**Loop_counter_width -1;
reg [Loop_counter_width-1:0] loop_counter;






reg sync_ff, sync_ff2;
















wire [4:0]  command        = rom_data[39:35];
wire [3:0]  A_address      = rom_data[34:31];
wire [3:0]  B_address      = rom_data[30:27];
wire [3:0]  write_address  = rom_data[26:23];
wire [3:0]  jump_cond      = rom_data[22:19];
wire [2:0]  reserved       = rom_data[18:16];
wire [15:0] immediate_data = rom_data[15:0];
wire loop_flag             = reserved[0];

wire [15:0] out_dataA, out_dataB;
wire [15:0] alu_data;




wire [15:0] Aport_data = (command== 5'b00001) ? immediate_data : port_in_data;




wire Reset_loop_counter = (loop_counter<2)||
                          (loop_counter==Stop_count && immediate_data == 16'b0)
                          ? 1 : 0;

always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                loop_counter <= Stop_count;
        end
        else if(Reset_loop_counter)
        begin
                loop_counter <= Stop_count;
        end
        else if(loop_flag && loop_counter==Stop_count)
        begin
                
                loop_counter <= immediate_data;
        end
        
        else if(loop_flag)
        begin
                
                loop_counter <= loop_counter - 16'b1;
        end
        else
        begin
                loop_counter <= Stop_count;
        end
end



always @(posedge clock, posedge reset) begin
        if (reset) sync_ff<=0;
        else    sync_ff<=sync;
end
always @(posedge clock, posedge reset) begin
        if (reset) sync_ff2<=0;
        else    sync_ff2<=sync_ff;
end

wire sync_pos_edge_detected = sync_ff & ~sync_ff2;




always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                pc <= 0;
        end
        
        else if(command== 5'b00101 && alu_data[0]==1'b1)
        begin
                
                pc <= immediate_data;
        end
        else if(command== 5'b00110)
        begin   
                if(sync_pos_edge_detected)
                begin
                        
                        pc <= pc + 1;
                end
                else
                begin
                        
                        pc <= pc;
                end
        end
        else if(loop_flag)
        begin   
                if(Reset_loop_counter)
                begin
                        
                        pc <= pc + 1;
                end
                else
                begin
                        
                        pc <= pc;
                end
        end
        else
        begin
                
                pc <= pc + 1;
        end
end



















register_file register_file(.clock(clock),
                        .reset(reset),
                        .A_address(A_address),
                        .B_address(B_address),
                        .write_address(write_address),
                        .alu_data(alu_data),
                        .out_dataA(out_dataA),
                        .out_dataB(out_dataB),
                        .port_in_data(Aport_data),
                        .port_out_data(port_out_data));


alu  alu(.command(command),
         .jump_cond(jump_cond),
         .portA(out_dataA),
         .portB(out_dataB),
         .alu_out(alu_data));


rom rom(.rom_address(pc),.Data(rom_data));


endmodule









module register_file(input  clock,
                     input  reset,
                     input  [3:0] A_address,
                     input  [3:0] B_address,
                     input  [3:0] write_address,
                     input  [15:0] alu_data, port_in_data,
                     output [15:0] out_dataA, out_dataB, port_out_data);


reg [15:0] p_out_reg, r0, r1, r2, r3;


always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                p_out_reg <= 0;
        end
        else if(write_address ==  4'b0110)
        begin
                p_out_reg <= alu_data;
        end
        else
        begin
                p_out_reg <= p_out_reg;
        end
end



always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r0 <= 0;
        end
        else if(write_address ==  4'b0001)
        begin
                r0 <= alu_data;
        end
        else
        begin
                r0 <= r0;
        end
end



always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r1 <= 0;
        end
        else if(write_address ==  4'b0010)
        begin
                r1 <= alu_data;
        end
        else
        begin
                r1 <= r1;
        end
end



always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r2 <= 0;
        end
        else if(write_address ==  4'b0011)
        begin
                r2 <= alu_data;
        end
        else
        begin
                r2 <= r2;
        end
end



always @(posedge clock, posedge reset) begin
        if(reset)
        begin
                r3 <= 0;
        end
        else if(write_address ==  4'b0100)
        begin
                r3 <= alu_data;
        end
        else
        begin
                r3 <= r3;
        end
end



assign out_dataA = (A_address== 4'b0110) ? p_out_reg :
                   (A_address== 4'b0101)  ? port_in_data :
                   (A_address== 4'b0001) ? r0 :
                   (A_address== 4'b0010) ? r1 :
                   (A_address== 4'b0011) ? r2 :
                   (A_address== 4'b0100) ? r3 : 16'b0;


assign out_dataB = (B_address== 4'b0110) ? p_out_reg :
                   (B_address== 4'b0101)  ? port_in_data :
                   (B_address== 4'b0001) ? r0 :
                   (B_address== 4'b0010) ? r1 :
                   (B_address== 4'b0011) ? r2 :
                   (B_address== 4'b0100) ? r3 : 16'b0;


assign port_out_data = p_out_reg;

endmodule




module alu(input [4:0] command,
           input [3:0] jump_cond,
           input [15:0] portA,portB,
           output reg [15:0] alu_out);

always @(*) begin
        case (command) 
                 5'b00000:     alu_out=portA+portB;
                 5'b00010:     alu_out=portA-portB;
                 5'b00011: alu_out=portB << 1;
                 5'b00100: alu_out=portB >> 1;

                 5'b01100:alu_out=portA << portB;
                 5'b01101:alu_out=portA >> portB;

                 5'b01011:     alu_out=portA * portB;


                 5'b00111:     alu_out=portA & portB;
                 5'b01000:      alu_out=portA | portB;
                 5'b01001:     alu_out=portA ^ portB;
                 5'b01010:     alu_out=~portA;

                 5'b00101:
                case (jump_cond) 
                         4'b0000:            alu_out=(portA == portB);
                         4'b0001:        alu_out=(portA != portB);
                         4'b0010:        alu_out=1;
                         4'b0011:    if (portA < portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                         4'b0100:    if (portA > portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                         4'b0101:   if (portA <= portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                         4'b0110:   if (portA >= portB)
                                        alu_out=1;
                                else
                                        alu_out=0;
                        default:        alu_out=0;
                endcase

                default: alu_out=portA+portB;
        endcase
end
endmodule






module rom(input  [15:0] rom_address,
           output [39:0] Data);


assign Data = romdata(rom_address);


wire [4:0]  command        = Data[39:35];
wire [3:0]  A_address      = Data[34:31];
wire [3:0]  B_address      = Data[30:27];
wire [3:0]  write_address  = Data[26:23];
wire [3:0]  jump_cond      = Data[22:19];
wire [15:0] im_val=Data[15:0];
wire [2:0] loop_cond=Data[18:16];



parameter [4:0] Set= 5'b00001,
                Add= 5'b00000,
                Sub= 5'b00010,
                Shift_L= 5'b00011,
                Shift_R= 5'b00100,
                Jmp= 5'b00101,
                Sync= 5'b00110,
                Mul= 5'b01011,
                And= 5'b00111,
                Or = 5'b01000,
                Xor= 5'b01001,
                Not= 5'b01010,
                BShift_L= 5'b01100,
                BShift_R= 5'b01101;

parameter [4:0] \Zbg = 5'b00001,
                \Z = 5'b00000,
                \Z = 5'b00010,
                \Vtg = 5'b00011,
                \EVtg = 5'b00100,
                \Wv = 5'b00101,
                \VN = 5'b00110,
                \Z = 5'b01011,
                \ = 5'b00111,
                \OR  = 5'b01000,
                \XOR = 5'b01001,
                \NOT = 5'b01010,
                \oVtg = 5'b01100,
                \EoVtg = 5'b01101;


parameter [3:0] P_OUT= 4'b0110,
                P_IN= 4'b0101,  
                R0=  4'b0001,
                R1=  4'b0010,
                R2=  4'b0011,
                R3=  4'b0100,
                ZR=  4'b0000; 


parameter [3:0] Eq= 4'b0000,
                Not_Eq= 4'b0001,
                Always= 4'b0010,
                LT= 4'b0011,
                GT= 4'b0100,
                LTE= 4'b0101,
                GTE= 4'b0110;


parameter [2:0] Reserved    = 3'b000,
                LoopEnabled = 3'b001;


































































reg [8*40:1] str;
function [8*3:1] get_rn(input [3:0] addr);
	case (addr) 
			P_OUT: get_rn="OUT";
			P_IN:    get_rn="IN";  
                   R0:      get_rn="R0";
                   R1:      get_rn="R1";
                   R2:      get_rn="R2";
                   R3:      get_rn="R3";
                   ZR:      get_rn="ZR"; 
			default: get_rn="???";
	endcase
endfunction

always @* begin
	case (command) 
		Add:
			if(loop_cond==0) begin
				if (A_address==ZR && B_address==ZR & write_address==ZR)  $sformat(str,"NOP");
				else if (B_address==ZR &&  A_address==ZR ) $sformat(str,"%sNA",get_rn(write_address));	
				else if (B_address==ZR ) $sformat(str,"%s%sփRs[",get_rn(A_address),get_rn(write_address));
				else $sformat(str,"%s=%s + %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			 end else begin
				if (A_address==ZR && B_address==ZR & write_address==ZR)  $sformat(str,"NOP %d[vt",im_val);
				else if (B_address==ZR &&  A_address==ZR ) $sformat(str,"%sNA@ %d[vt",get_rn(write_address),im_val);	
				else if (B_address==ZR ) $sformat(str,"%s%sփRs[@ %d[vt",get_rn(A_address),get_rn(write_address),im_val);
				else  $sformat(str,"%s=%s + %s  %d[vt",get_rn(write_address),get_rn(A_address),get_rn(B_address),im_val);
			end
		Set:  $sformat(str,"%s=%h[Hex]",get_rn(write_address),im_val);
		Mul:
			if (loop_cond==0) begin
				 $sformat(str,"%s=%s * %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			end else $sformat(str,"%s=%s * %s @ %d[vt",get_rn(write_address),get_rn(A_address),get_rn(B_address),im_val);
		Sub:
			if (loop_cond==0) begin
				 $sformat(str,"%s=%s - %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			end else  $sformat(str,"%s=%s - %s  %d[vt",get_rn(write_address),get_rn(A_address),get_rn(B_address),im_val);
		Sync:
			$sformat(str,"VN");
			
		Not: $sformat(str,"%s=~%s",get_rn(write_address),get_rn(A_address));
		Jmp:
			if (jump_cond==Always) $sformat(str,"%dԒnփWv",im_val);
			else if (jump_cond==LT) $sformat(str,"%s < %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val);
			else if (jump_cond==GT) $sformat(str,"%s > %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val);
			else if (jump_cond==LTE) $sformat(str,"%s <= %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val);
			else if (jump_cond==GTE) $sformat(str,"%s >= %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val); 
			else if (jump_cond==Eq)  $sformat(str,"%s == %s Ȃ%dԒnփWv",get_rn(A_address),get_rn(B_address),im_val); 
		Shift_L:
				if (loop_cond==0)		$sformat(str,"%s=%s << 1",get_rn(write_address),get_rn(B_address));
				else			      $sformat(str,"%s=%s << %d",get_rn(write_address),get_rn(B_address),im_val);
			 
		Shift_R: 
				if (loop_cond==0)		$sformat(str,"%s=%s >> 1",get_rn(write_address),get_rn(B_address));
				else			      $sformat(str,"%s=%s >> %d",get_rn(write_address),get_rn(B_address),im_val);

		BShift_L:
			      $sformat(str,"%s=%s <<%s",get_rn(write_address),get_rn(A_address),get_rn(B_address));
			 
		BShift_R: 
			      $sformat(str,"%s=%s >> %s",get_rn(write_address),get_rn(A_address),get_rn(B_address));

	endcase
end




function [39:0]romdata;
        input [15:0] address;
        case(address)
        
        0:  romdata = { Set , P_IN , ZR ,  P_OUT , Eq , Reserved , 16 'd    100 };
        1:  romdata = { Set , P_IN , ZR ,  R0 , Eq , Reserved , 16 'd    5 };
        2:  romdata = { Add ,  R0 , ZR ,    R1 , Eq , Reserved , 16'h 0000 };
        3:  romdata = { Add ,  R1 , ZR ,    R2 , Eq , Reserved , 16'h 0000 };
        4:  romdata = { Add ,  R2 , ZR ,    R3 , Eq , Reserved , 16'h 0000 };
        5:  romdata = { Sub ,  R1 ,    R2 ,    R0 , Eq , Reserved , 16'h 0000 };
        6:  romdata = { Sub ,  R3 ,    R1 ,    R3 , Eq , Reserved , 16'h 0000 };
        7:  romdata = { Add ,  P_IN ,    P_OUT ,    P_OUT , Eq , Reserved , 16'h 0000 };
        8:  romdata = { Add ,  P_OUT ,    P_OUT ,    P_OUT , Eq , Reserved , 16'h 0000 };
        9:  romdata = { Sub ,  P_IN ,    P_IN ,    R1 , Eq , Reserved , 16'h 0000 };
        10:  romdata = { Sub ,  P_OUT ,    P_IN ,    R2 , Eq , Reserved , 16'h 0000 };
        11:  romdata = { Set , P_IN , ZR ,  R0 , Eq , Reserved , 16 'd    2 };
        12:  romdata = { Set , P_IN , ZR ,  R1 , Eq , Reserved , 16 'd    8 };
        13:  romdata = { Mul ,  R0 ,    R1 ,    R3 , Eq , Reserved , 16'h 0000 };
        14:  romdata = { Add , ZR , ZR , ZR , Eq , Reserved , 16'h 0000 };
        15:  romdata = { Mul ,  R3 ,    R3 ,    R3 , Eq , Reserved , 16'h 0000 };
        16:  romdata = { Add ,  P_OUT ,    R3 ,    P_OUT , Eq , Reserved , 16'h 0000 };
        17:  romdata = { Sync , ZR , ZR , ZR , Eq , Reserved , 16'h 0000 };
        18:  romdata = { Jmp , ZR , ZR , ZR , Always , Reserved , 16 'd  1000 };

        
        1000:  romdata = { Set , P_IN , ZR ,  R0 , Eq , Reserved , 16 'd    5 };
        1001:  romdata = { Set , P_IN , ZR ,  R1 , Eq , Reserved , 16 'd    2 };
        1002:  romdata = { Add ,  R0 ,    R1 ,    R0 , Eq , LoopEnabled , 16 'd    10 };
        1003:  romdata = { Shift_L , ZR ,  R1 ,  R1 , Eq , LoopEnabled , 16 'd    5 };
        1004:  romdata = { Shift_R , ZR ,  R1 ,  R1 , Eq , LoopEnabled , 16 'd    5 };
        1005:  romdata = { Sub ,  R0 ,    R1 ,    R0 , Eq , LoopEnabled , 16 'd    10 };
        1006:  romdata = { Set , P_IN , ZR ,  P_OUT , Eq , Reserved , 16 'd    5 };
        1007:  romdata = { Mul ,  P_OUT ,    R1 ,    P_OUT , Eq , LoopEnabled , 16 'd    7 };
        1008:  romdata = { Jmp , ZR , ZR , ZR , Always , Reserved , 16 'd  1500 };

        
        1500:  romdata = { Set , P_IN , ZR ,  R0 , Eq , Reserved , 16 'd    16 };
        1501:  romdata = { Set , P_IN , ZR ,  R1 , Eq , Reserved , 16 'd    2 };
        1502:  romdata = { Set , P_IN , ZR ,  P_OUT , Eq , Reserved , 16 'd    0 };
        1503:  romdata = { Sub ,  R0 ,    R1 ,    R0 , Eq , Reserved , 16'h 0000 };
        1504:  romdata = { Jmp ,  R0 ,    R1   , ZR , GT , Reserved , 16 'd  1503 };

        
        1505:  romdata = { Set , P_IN , ZR ,  R2 , Eq , Reserved , 16 'd    16 };
        1506:  romdata = { Set , P_IN , ZR ,  R3 , Eq , Reserved , 16 'd    2 };
        1507:  romdata = { Set , P_IN , ZR ,  P_OUT , Eq , Reserved , 16 'd    0 };
        1509:  romdata = { Sub ,  R2 ,    R3 ,    R2 , Eq , Reserved , 16'h 0000 };
        1511:  romdata = { Jmp ,  R2 ,    R3   , ZR , GTE , Reserved , 16 'd  1509 };

        
        
        1512:  romdata = { Set , P_IN , ZR ,  R0 , Eq , Reserved , 16 'd    43690 };
        1513:  romdata = { Not ,  R0 , ZR ,    R1 , Always , Reserved , 16'h 0000 };

        
        1514:  romdata = { Set , P_IN , ZR ,  R0 , Eq , Reserved , 16 'd    2 };
        1515:  romdata = { Set , P_IN , ZR ,  R1 , Eq , Reserved , 16 'd    7 };
        1516:  romdata = { Set , P_IN , ZR ,  R2 , Eq , Reserved , 16 'd    0 };
        1517:  romdata = { BShift_L ,  R0 ,    R1 ,    R0 , Eq , Reserved , 16'h 0000 };
        1518:  romdata = { BShift_R ,  R0 ,    R1 ,    R0 , Eq , Reserved , 16'h 0000 };

	1519:  romdata = { Jmp , ZR , ZR , ZR , Always , Reserved , 16 'd  0 };

        default:  romdata = 0;
        endcase
endfunction
endmodule



